#include "gloop.h"

//////////////////////////////////////////////////////////////////////

void ScreenMode(int mode)
{
	asm {
			mov ax,mode
			int 0x10
	}
}

void setpal(uchar *pal)
{

//	int oldseg,oldoff;
//	oldseg=FP_SEG(pal);
//	oldoff=FP_OFF(pal);
	asm {
			mov	ax,0x1012
			mov bx,0
			mov cx,256
		//	mov dx,oldseg
		//	mov es,dx
		//	mov dx,oldoff
			les dx,pal
			int 0x10
   };
}

void Load_PCX_data(FILE *fp,uchar far *where,int xscan,int yscan)
{
	int xcount,ycount,i;
	uchar buf,tbuf;

	for(ycount=0;ycount<yscan;ycount++)
	{
		xcount=0;
		while(xscan>xcount)
		{
			buf=fgetc(fp);
			if (buf>=192)
			{
				tbuf=buf-192;
				xcount+=tbuf;
				buf=fgetc(fp);
				for(i=0;i<tbuf;i++,where++)
				{
					*where=buf;   // this line doesn't work on a 586!!
				}
			}
			else
			{
				xcount++;
				*where=buf;
				where++;
			}
		}
	}
}

struct Picture_Type *Setup_PT(long Buffsize,int flags)
{
	uchar far *where;
	struct Picture_Type *pic=NULL;
	where=farcalloc(Buffsize,1);

	if(where)
	{
		pic=malloc(sizeof(struct Picture_Type));
		if(pic)
		{
			pic->Data=where;
			if(flags & 1)
			{
				pic->Palette=malloc(768);
				if(pic->Palette)
				{
					return(pic);
				}
				free(pic->Palette);
			}
			else return(pic);
			free(pic);
		} else printf("malloc(Picture_Type)\n");
		farfree(where); // pic failed
	}
	else printf("farmalloc() failed to allocate %ld Bytes\n",Buffsize);
	return(NULL);
}

struct Picture_Type *Load_PCX(char *name,int flags)
{
	FILE *fp;
	int j,i;
	uchar far *where;
	uchar *pal;
	int yscan=64,xscan=64;
	struct Picture_Type *pic=NULL;
	fp=fopen(name,"rb");
	if(fp)
	{
		for(j=0;j<4;j++) fgetc(fp);	// should check PCX
		for(j=0;j<4;j++) fgetc(fp); // dummies
		xscan=fgetc(fp)+(fgetc(fp)<<8)+1;
		yscan=fgetc(fp)+(fgetc(fp)<<8)+1;
		pic=Setup_PT((long)((long)(xscan)*(long)(yscan)),flags);
		if(pic)
		{
			where=pic->Data;

		//	pic->Palette=NULL;
			pic->Width=xscan;
			pic->Height=yscan;
			fseek(fp,128,SEEK_SET);
			Load_PCX_data(fp,where,xscan,yscan);
			if(flags & LP_LOAD_PALETTE)
			{
				pal=pic->Palette;
				fseek(fp,-768,SEEK_END);
				for(i=0;i<768;i++) *(pal++)=(fgetc(fp) >> 2);
				if(flags & LP_SET_PALETTE) setpal(pal);

			}
		}
		else
		{
			printf("Error: Memory -- Setup_PT\n");
			getch();
		}
	}
	return(pic);
}

void ClearScreen(void)
{
	asm {
		push	ds
		mov		cx,0xA000
		mov		ds,cx
		mov		bx,0
		mov		cx,64000
		mov		dl,0
	}
	nxtdot:
	asm {
		mov     ds:[bx],dl
		inc 	bx
		loop 	nxtdot
		pop		ds
	}
}

void ShowPic(struct Man_Type *man,int flags)
{
	int i,j;
	int offset=0;

	uchar far *screen,*temp;

	temp=man->Picture->Data + man->Frame * 256;

	offset=(((man->y)*320)+(man->x));
	screen=MK_FP(0xA000,offset);

	if(flags & SP_CLEAR_FIRST) ClearScreen();
	if(flags & SP_SET_PALETTE) setpal(man->Picture->Palette);


	if((flags & SP_DONT_DISPLAY)==0)
	{
		for(i=0;i<man->Picture->Height;i++)
		{
			for(j=0;j<man->Picture->Width;j++)
			{
				*screen++=*temp++;
			}
			screen+=(320-j);
		}
	}
}

void FreePic(struct Picture_Type *pic)
{
	if(pic)
	{
		printf("Freeing");
		getch();
		if(pic->Palette) free(pic->Palette);
		if(pic->Data) free(pic->Data);
		free(pic);
	}
	else printf("Already freed\n");
}

struct Man_Type *Load_Walls(void)
{
	int k;
	uchar far *temp;
	FILE *fp;
	struct Man_Type *man=NULL;
	char name[]="c:\\c\\bc\\programs\\gloop\\pcx\\GMENXX.PCX";

	man->Picture=Setup_PT((long)((long)(2)*(long)(256)),0);

	if(man->Picture)
	{
		for(k=1;k<3;k++)
		{
			name[31]=(k/10)+48;
			name[32]=(k%10)+48;
			temp=(man->Picture->Data)+((k-1)*(16*16));
			fp=fopen(name,"rb");
			if(fp!=NULL)
			{
				fseek(fp,128,SEEK_SET);
				Load_PCX_data(fp,temp,16,16);
				fclose(fp);
			}
			else
			{
				printf("Error: %s\n",name);
				getch();
			}
		}
	}
	else printf("Error Load_Walls() (Setup_PT) !!\n");
	return(man);
}

void LoadPaletteScreen(char *name)
{
	FILE *fp;
	int i;
	uchar pal[768];
	fp=fopen(name,"rb");
	if(fp)
	{
		fseek(fp,-768,SEEK_END);
		for(i=0;i<768;i++) pal[i]=(fgetc(fp) >> 2);
		setpal(pal);
		fclose(fp);
	}else printf("Can't open file to load palette from\n");
}


void WaitRetrace(void)
{
	asm {
			mov		dx,0x03DA
	}
	waitsomemore:
	asm {
			in		al,dx
			test	al,0x08
			jnz		waitsomemore
	}
}
