#include"gloop.h"

void ScreenMode(int mode)
{
	asm {
			mov ax,mode
			int 0x10
	}
}

void setpal(uchar *pal)
{

	asm {
			mov ax,	0x1012
			mov bx,	0
			mov cx,	256
			les dx,	pal

			int 0x10
   };
}

void Load_PCX_data(FILE *fp,uchar huge *where,int xscan,int yscan)
{
	long int xcount,ycount,i;
	uchar buf,tbuf;
	for(ycount=0;ycount<yscan;ycount++)
	{
		xcount=0;
		while(xscan>xcount)
		{
			buf=fgetc(fp);
			if (buf>=192)
			{
				tbuf=buf-192;
				xcount+=tbuf;
				buf=fgetc(fp);
				for(i=0;i<tbuf;i++,where++)
				{
					*where=buf;   // this line doesn't work on a 586!!
				}
			}
			else
			{
				xcount++;
				*where=buf;
				where++;
			}
		}
	}
}

struct Picture_Type *Setup_PT(long Buffsize,int flags)
{
	uchar huge *where;
	struct Picture_Type *pic=NULL;
	where=farcalloc(Buffsize,1);

	if(where)
	{
		pic=malloc(sizeof(struct Picture_Type));
		if(pic)
		{
			pic->Data=where;
			if(flags & 1)
			{
				pic->Palette=malloc(768);
				if(pic->Palette)
				{
					return(pic);
				}
				free(pic->Palette);
			}
			else return(pic);
			free(pic);
		} else printf("malloc(Picture_Type)\n");
		farfree(where); // pic failed
	}
	else printf("farcalloc() failed to allocate %ld Bytes\n",Buffsize);
	return(NULL);
}

void ShowPic(struct Picture_Type *pic,int flags,struct Man_Type *man,
		uchar far *screen,int offset)
{
	int i,j;
	uchar huge *temp;
	temp= pic->Data + ((man->Frame)<<8);
       //	screen=MK_FP(0xA000,(man->x)+((man->y<<6)+(man->y<<8)));
	screen+=(man->x-offset)+(man->y<<6)+(man->y<<8);

	if(flags & SP_CLEAR_FIRST) ClearScreen();
	if(flags & SP_SET_PALETTE) setpal(pic->Palette);
	if((flags & SP_DONT_DISPLAY)==0)
	{
		for(i=0;i<pic->Height;i++)
		{
			for(j=0;j<pic->Width;j++)
			{
				if (*temp!=0)
					*screen=*temp;
					screen++;
					temp++;
			}
			screen+=(320-j); // 320-j = 320 -15= 305
		}
	}
}

struct Picture_Type *Load_Men(void)
{
	int k,j,xscan,yscan;
	uchar huge *temp;
	FILE *fp;
	struct Picture_Type *pic=NULL;
	char name[]="pcx\\GMENXX.PCX";

	pic=Setup_PT((long)(((long)(10))*((long)(256))),0);

	if(pic)
	{
		for(k=1;k<11;k++)
		{
			name[8]=(k/10)+48;
			name[9]=(k%10)+48;
			temp=(pic->Data)+((((k-1)))*(16*16));
			fp=fopen(name,"rb");
			if(fp)
			{
				for(j=0;j<4;j++) fgetc(fp);	// should check PCX
				for(j=0;j<4;j++) fgetc(fp); // dummies
				xscan=fgetc(fp)+(fgetc(fp)<<8)+1;
				yscan=fgetc(fp)+(fgetc(fp)<<8)+1;
				pic->Width=xscan;
				pic->Height=yscan;

				printf("%d:%d",xscan,yscan);
				fseek(fp,128,SEEK_SET);
				Load_PCX_data(fp,temp,xscan,yscan);

				fclose(fp);
			}
			else
			{
				printf("Error: %s\n",name);
				getch();
			}
		}
	}
	else printf("Error Load_Men() (Setup_PT) !!\n");
	return(pic);
}
struct Picture_Type *Load_Gloop(void)
{
	int k,j,xscan,yscan;
	uchar huge *temp;
	FILE *fp;
	struct Picture_Type *pic=NULL;
	char name[]="pcx\\GLOOPXX.PCX";

	pic=Setup_PT((long)(((long)(2))*((long)(16*16))),0);

	if(pic)
	{
		for(k=1;k<3;k++)
		{
			name[9]=(k/10)+48;
			name[10]=(k%10)+48;
			temp=(pic->Data)+((((k-1)))*(16*16));
			fp=fopen(name,"rb");
			if(fp)
			{
				for(j=0;j<4;j++) fgetc(fp);	// should check PCX
				for(j=0;j<4;j++) fgetc(fp); // dummies
				xscan=fgetc(fp)+(fgetc(fp)<<8)+1;
				yscan=fgetc(fp)+(fgetc(fp)<<8)+1;
				pic->Width=xscan;
				pic->Height=yscan;

				printf("%d:%d",xscan,yscan);
				fseek(fp,128,SEEK_SET);
				Load_PCX_data(fp,temp,xscan,yscan);

				fclose(fp);
			}
			else
			{
				printf("Error: %s\n",name);
				getch();
			}
		}
	}
	else printf("Error Load_Gloop() (Setup_PT) !!\n");
	return(pic);
}

struct Picture_Type *Load_PCX(char *name,int flags)
{
	FILE *fp;
	int j,i;
	uchar huge *where;
	uchar *pal;
	int yscan=640,xscan=200;
	struct Picture_Type *pic=NULL;
	fp=fopen(name,"rb");
	if(fp)
	{
		for(j=0;j<4;j++) fgetc(fp);	// should check PCX
		for(j=0;j<4;j++) fgetc(fp); // dummies
		xscan=fgetc(fp)+(fgetc(fp)<<8)+1;
		yscan=fgetc(fp)+(fgetc(fp)<<8)+1;
                printf("back");
		pic=Setup_PT((long)((long)(xscan)*(long)(yscan)),flags);
		if(pic)
		{
			where=pic->Data;

			pic->Width=xscan;
			pic->Height=yscan;
			fseek(fp,128,SEEK_SET);
			Load_PCX_data(fp,where,xscan,yscan);
			if(flags & LP_LOAD_PALETTE)
			{
				pal=pic->Palette;
				fseek(fp,-768,SEEK_END);
				for(i=0;i<768;i++) *(pal++)=(fgetc(fp) >> 2);
				if(flags & LP_SET_PALETTE) setpal(pal);

			}
		}
		else
		{
			printf("Error: Memory -- Setup_PT\n");
			getch();
		}
	}
	return(pic);
}

void LoadPaletteScreen(char *name)
{
	FILE *fp;
	int i;
	uchar pal[768];
	fp=fopen(name,"rb");
	if(fp)
	{
		fseek(fp,-768,SEEK_END);
		for(i=0;i<768;i++) pal[i]=(fgetc(fp) >> 2);
		setpal(pal);
		fclose(fp);
	}else printf("Can't open file to load palette from\n");
}

void FreePic(struct Picture_Type *pic)
{
	if(pic)
	{
		if(pic->Palette) free(pic->Palette);
		if(pic->Data) free(pic->Data);
		free(pic);
	}
	else printf("Already freed\n");
}

void FreeMan(struct Man_Type *man)
{
	if(man)
	{
		free(man);
		printf("Freeing");
	}
	else printf("Man was already freed\n");
}
void ClearScreen(void)
{
	asm {
		push	ds
		mov		cx,0xA000
		mov		ds,cx
		mov		bx,0
		mov		cx,64000
		mov		dl,0
	}
	nxtdot:
	asm {
		mov     ds:[bx],dl
		inc 	bx
		loop 	nxtdot
		pop		ds
	}
}

void WaitRetrace(void)
{
	asm {
			mov		dx,0x03DA
	}
	waitsomemore:
	asm {
			in		al,dx
			test	al,0x08
			jnz		waitsomemore
	}
}

/* The magic matrix, scaling translating rotating all in one go !!!*/

void Init_Matrix(	float xangle, float yangle, float zangle,
					float mat[4][4])
{
	float sx,sy,sz,cx,cy,cz;

//	sx = 0;//sin(xangle); //   ===0 !!! Gone !
//	sy = 0;//sin(yangle); //   === 0 !!! Gone !
	sz = sin(zangle);

//	cx = 1;//cos(xangle); //   ===1 Gone
	cy = 1;//cos(yangle); //      =1 Gone !!!
	cz = cos(zangle);

	mat[0][0] = ((cz));// - (sz * 0 * sy));

	mat[0][1] =  sz;

//	mat[0][2] = ((cz * sy) + (sz * sx * cy));

//	mat[0][3] = 0;

	mat[1][0] = -(sz);// + (cz * 0 * 0));

	mat[1][1] = cz;

//	mat[1][2] = ((-sz * sy) + (cz * sx * cy));

//	mat[1][3] = 0;

//	mat[2][0] = -1 * cx * sy ;

//	mat[2][1] = -1*sx ;

//	mat[2][2] = cx * cy ;

//	mat[2][3] = 0;

//	mat[3][0] = 0;//xtranslation;
//	mat[3][1] = 0;//ytranslation;
//	mat[3][2] = 0;//ztranslation;
//	mat[3][3] = 1;

}

void ShowRotatedPic(struct Picture_Type *pic,int flags,
					struct Man_Type *man, uchar far * screen,
					float mat[4][4])
{
	int i,j;
	float tmpx=0,tmpy=0;
	int tx=0,ty=0;

	uchar huge *temp;
	temp= pic->Data + ((man->Frame)<<8);

//	if(flags & SP_CLEAR_FIRST) ClearScreen();
//	if(flags & SP_SET_PALETTE) setpal(pic->Palette);
//	if((flags & SP_DONT_DISPLAY)==0)
	{
		for(i=0;i<pic->Height;i++)
		{

			for(j=0;j<pic->Width;j++)
			{
				if (*temp!=0)
				{
tmpx=(float)(float)((float)((j - ( pic->Width >> 1 )) * mat[0][0]) +
		   (float)( i - ( pic->Height >> 1 )) * mat[1][0] + man->x);

tmpy=320*(int)((float)((((((float)(( j - ( pic->Height >> 1)) * mat[0][1]) +
		   (float)( i - ( pic->Width >> 1 )) * mat[1][1] + man->y)))))/1.3);
					tx=tmpx;
					ty=tmpy;

					*(screen+tx+(ty))=*temp;
				}

					temp++;
			}

		}
	}
}

